#include <win>
using namespace Win;

#include <iostream>
using namespace std;

#include "../Images/tools.h"
#include "../Images/lmeds.h"
#include "../Images/image.h"
#include <string>
	/* 
	const char* fichier1="../Data/Mosaic/Cannes/miniimage00003.jpg";
	const char* fichier2="../Data/Mosaic/Cannes/miniimage00004.jpg";
	*/

	/* 
	const char* fichier1="../Data/Mosaic/Cannes/image0003.jpg";
	const char* fichier2="../Data/Mosaic/Cannes/image0004.jpg";
	*/ 
	
/*
Cette image montre bien l'efficacit de ma mthode de raccord :
le ciel est bien dgrad (l'intensit du ciel de gauche et de celui
de droite sont en effet totalement diffrentes) et la transition
est nette pour le reste, surtout la ligne que l'on voit en bas,
dont la jonction est bien ralise.
*/
	///*
	const char* fichier1="../Data/Mosaic/MPrague1.jpg";
	const char* fichier2="../Data/Mosaic/MPrague2.jpg";
	//*/

	/*
	const char* fichier1="../Data/Mosaic/Foret/Arbo1.pgm";
	const char* fichier2="../Data/Mosaic/Foret/Arbo2.pgm";
	*/

const int N=10;
const int Diam=10;

/*
Le rayo ci-dessous doit tre infrieur ou gal  Diam/2
(il ne doit pas y avoir de point de Harris  distance
infrieure  rayo du bord de l'image).
Il correspond au rayon utilis pour la corrlation, ainsi,
plus il est grand, plus la corrlation prendra du temps.
Un rayon de 2 donnera un algo assez rapide, pour 5, a prendra
pas mal de temps.
*/
const int Rayo=3;

/*Nombre de points de Harris voulus (infrieur  1000) pour la
corrlation. 60 marche bien, attention  ne pas en mettre trop
sinon la corrlation fait n'importe quoi.
*/
const int nbharris=50;
double X[N],Y[N],Z[N],T[N];

/*
Points de Harris :

Prend en entre le chemin d'un fichier image, le nombre
de points de Harris voulu, et l'cartement minimal entre
ces points.
Elle se restreint aux points d'abscisse comprise entre
imin et imax, et d'ordonne comprise entre ymin et ymax.
Renvoie une image de largeur double de l'image de dpart,
avec :
- sur la gauche, une image avec des 255 pour chaque
point de Harris, et 0 sinon.
- sur la droite, une image reprsentant H(x,y) pour tout
pixel (x,y).
*/
image Harris(const char* fichier,int diametre,int imin,int imax,int jmin, int jmax,int Manuel)
{
//On charge l'image dans une fentre deux fois plus grande.
	image A(fichier);

	int h=A.height();
	int w=A.width();
	A.display();
	if (Manuel==1) Click();
    
    dimage Imaj=A;
	Imaj.display(w,0);
	if (Manuel==1) Click();

	dimage DX=Imaj.deriche(1,0,0);
	DX.display(w,0);
	if (Manuel==1) Click();

	dimage DY=Imaj.deriche(0,1,0);
	DY.display(w,0);
	if (Manuel==1) Click();

/*
On calcule les valeurs de A (DDX), B(DDY) et C(DXDY) sur l'image
*/
	image DDY(w,h);
	image DDX(w,h);
	image DXDY(w,h);
	double tempX,tempY,tempXY;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DX(i,j))/256;
			tempY=(DY(i,j))/256;
			DDY(i,j)=byte (256 * (tempY*tempY)) ;
	     	DDX(i,j)=byte (256 * (tempX*tempX)) ;
			DXDY(i,j)=byte (256 * (tempX*tempY));
		}
	}
	
/*
On lisse A(DDX) B(DDY) et C(DXDY) pour obtenir respectivement DDDX, DDDY, DDDXY.
*/
	//!! Apparemment on doit dupliquer l'image avant d'appliquer
	//deriche, sinon on a l'erreur : 'deriche': n'est pas membre de 'image'...???
	dimage DXYTemp=DXDY;
	dimage DDDXY=DXYTemp.deriche(0,0,0.3);	
	dimage DXTemp=DDX;
	dimage DDDX=DXTemp.deriche(0,0,0.3);	
	dimage DYTemp=DDY;
	dimage DDDY=DYTemp.deriche(0,0,0.3);	
	
	DDY.display();
	DDDY.display(w,0);
	if (Manuel==1) Click();

	DDX.display();
	DDDX.display(w,0);
	

	if (Manuel==1) Click();

	DXDY.display();
	DDDXY.display(w,0);
	//if (Manuel==1) Click();

	
/*
On va afficher HH en convertissant HH(x,y) en intensit lumineuse associe.
C'est pourquoi, lors du calcul de HH, on garde en mmoire le max et le min
des valeurs rencontres
*/
	image HH(w,h);

	double min=0;
	double max=0;
	double tempdouble;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DDDX(i,j))/256;
			tempY=(DDDY(i,j))/256;
			tempXY=(DDDXY(i,j))/256;
			tempdouble = (tempX*tempY-tempXY*tempXY)-0,04*(tempX+tempY);
	
			if (tempdouble<min)
				min=tempdouble;
			if (tempdouble>max)
				max=tempdouble;
		}
	}
	cout << "max : " << max <<" ";
	cout << "min : " << min <<" ";
	cout << endl;
	
//On calcule l'image associe  HH...
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			tempX=(DDDX(i,j))/256;
			tempY=(DDDY(i,j))/256;
			tempXY=(DDDXY(i,j))/256;
			HH(i,j)=byte (255*   (tempX*tempY-tempXY*tempXY-0,04*(tempX+tempY))/(max-min)) ;
		}
	}
	
//... Et on l'affiche
	cout << "Affichage de H" <<endl;
	HH.display();
	if (Manuel==1) Click();

//Image qui sera retourne par la fonction
image MaxLoc(2*w,h);

//Nombre points de Harris que l'on va trouver tout d'abord.
int nombrepoints=0;

/*
Mthode de "pics" :
Pour trouver les maximas locaux de H, on prend tous les points
d'intensit strictement suprieure  celle de ses 8 voisins.

J'ai essay cette mthode aprs celle des grilles (qui suit)
et bizarrement, elle fonctionne beaucoup moins bien en
pratique...
*/
/*
for (int i=(int) (diametre/2);i<(int) (w-diametre/2);i=i+1)
	{
		for (int j=(int) (diametre/2);j<(int) (h-diametre/2);j=j+1)
		{
			//Si le point est d'intensit suprieure  celle de ses 8 voisins
			if ((HH(i,j)>HH(i-1,j)) && (HH(i,j)>HH(i-1,j-1)) && (HH(i,j)>HH(i,j-1)) && (HH(i,j)>HH(i+1,j-1))
				&& (HH(i,j)>HH(i+1,j)) && (HH(i,j)>HH(i+1,j+1)) && (HH(i,j)>HH(i,j+1)) && (HH(i,j)>HH(i-1,j+1)))
			{
				//Et qu'il appartient bien  la fentre dlimite prcdemment,
				//o les deux images se recouvrent.
				if ((i>imin) && (i<imax) && (j>jmin) && (j<jmax))
				{
					MaxLoc(i,j)=255;
					nombrepoints++;
				}
				else
					MaxLoc(i,j)=0;
			}
			else
				MaxLoc(i,j)=0;
		}
	}
*/


/*
Mthode de "grilles" :
Pour trouver les maximas locaux de H, on prend une grille et
on les cherche dans chaque case d'un certain diamtre dfini
en fonction des dimensions de l'image.
*/
///*
	int itrouve;
	int jtrouve;
	int htrouve;
	for (int i=0;i<w;i=i+diametre)
	{
		for	(int j=0;j<h;j=j+diametre)
		{
			itrouve=i;
			jtrouve=j;
			htrouve=HH(i,j);
			for (int ii=0;(ii<diametre) && (i+ii<w);ii++)
			{
				for	(int jj=0;(jj<diametre) && (j+jj<h);jj++)
				{
					if (HH(i+ii,j+jj)>htrouve)
					{
						MaxLoc(itrouve,jtrouve)=0;
						MaxLoc(i+ii,j+jj)=255;
						htrouve=HH(i+ii,j+jj);
						itrouve=i+ii;
						jtrouve=j+jj;
					}
					else
						MaxLoc(i+ii,j+jj)=0;
					if ((i+ii>imax) || (i+ii<imin) || (j+jj>jmax) || (j+jj<jmin))
						MaxLoc(i+ii,j+jj)=0;
				}
			}

		}
	}

	MaxLoc.display(w,0);
	if (Manuel==1) Click();

//On refait la mme chose en dcalant la grille
min=255;
max=0;
	for (int i=(int) (diametre/2);i<w;i=i+diametre)
	{
		for	(int j=(int) (diametre/2);j<h;j=j+diametre)
		{
			itrouve=i;
			jtrouve=j;
			htrouve=0;
			for (int ii=0;(ii<diametre) && (i+ii<w);ii++)
			{
				for	(int jj=0;(jj<diametre) && (j+jj<h);jj++)
				{
				if (MaxLoc(i+ii,j+jj)>0)
				{
					if (HH(i+ii,j+jj)>htrouve)
						{
							MaxLoc(itrouve,jtrouve)=0;
							MaxLoc(i+ii,j+jj)=255;
							htrouve=HH(i+ii,j+jj);
							itrouve=i+ii;
							jtrouve=j+jj;
						}
						else
							MaxLoc(i+ii,j+jj)=0;
					//On vrifie bien qu'on ne prend pas de point sur les bords
					if ((i+ii>imax) || (i+ii<imin) || (j+jj>jmax) || (j+jj<jmin))
						MaxLoc(i+ii,j+jj)=0;
					}
				}
			}
			if (htrouve>0)
				nombrepoints++;

		if ((htrouve>0) && (htrouve<min))
			min=htrouve;
		if (htrouve>max)
			max=htrouve;
		}
	}
//Fin de la mthode de "grilles" pour trouver les points de Harris.
//*/

	MaxLoc.display(w,0);
	cout << "Nombre de points trouves : " << nombrepoints << endl;
	if (Manuel==1) Click();


/*
On a donc MaxLoc gal  1 pour tous les coins trouvs, 0 sinon.

Ci dessous, on rduit le nombre de points trouvs en en prenant environ
nbharris, de valeur maximale.
*/
	int seuil=127;
	int precision=64;
	while (precision>1)
	{
		nombrepoints=0;
		
		//On ne doit pas prendre de points trop prs des bords :
		int rayon=(int) diametre/2;

		//On cherche alors par dichotomie (precision est la longueur du
		//segment de chaque tape de la dichotomie) le seuil d'intensit
		//tel que l'on trouve nombrepoints points de Harris d'intensit
		//suprieure  ce seuil dans HH finalement.
		for (int i=rayon;i<w-rayon;i++)
		{
		for	(int j=rayon;j<h-rayon;j++)
		{
			if (MaxLoc(i,j)==255)
			{
				if (HH(i,j)>=seuil)
					nombrepoints++;
			}
		}
		}
		if (nombrepoints>nbharris)
            seuil=seuil+precision;
		else
			seuil=seuil-precision;
		precision=precision/2;
	}
	cout << "Seuil : " << seuil << endl;
	cout << "Nombre de points finalement : " << nombrepoints << endl;
    
//Ca y est, on a identifi le bon seuil, on va maintenant marquer les points.
	int rayon=(int) (diametre/2);
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (MaxLoc(i,j)==255)
			{
			if (HH(i,j)>=seuil)
			{
				if ((i>=rayon) && (i<w-rayon) && (j>=rayon) && (j<h-rayon))
					MaxLoc(i,j)=255;
				else
					MaxLoc(i,j)=0;
			}
			else
				MaxLoc(i,j)=0;
			}				
		}
	}

//On recopie l'image HH dans la partie droite de MaxLoc
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			MaxLoc(w+i,j)=HH(i,j);
		}
	}
	MaxLoc.display(w,0);
	if (Manuel==1) Click();

return MaxLoc;
}


/*
Les 4 fonctions suivantes sont dfinies dans la partie Corrlation de l'nonc.
*/

//On a pris nos prcautions avant pour que la fentre autour du
//point (x,y) soit entirement  l'intrieur de l'image.
double Moyenne(int x,int y,int rayon,image imaj)
{
	double temp=0;
	double moyen=0;
	for (int i=x-rayon;i<=x+rayon;i++)
	{
		for	(int j=y-rayon;j<=y+rayon;j++)
		{
			temp=((double) imaj(i,j))/256;
			moyen=(moyen+temp);
		}
	}
	//cout << "Scalaire : "<< moyen<< endl;
	return (moyen/((2*rayon+1)*(2*rayon+1)));
}

double Scalaire(int xa,int ya,int xb,int yb,int rayon,image imaj1,image imaj2)
{
	double moyen=0;
	double temp=0;
	for (int u=-rayon;u<=rayon;u++)
	{
		for	(int v=-rayon;v<=rayon;v++)
		{
			//cout << "Scalaire : "<< temp <<"|"<< -Moyenne(xa,ya,rayon,imaj1)<<"|"<<-Moyenne(xb,yb,rayon,imaj2)<< endl;
			moyen= (moyen+ (((double) imaj1(xa+u,ya+v)) /256 - Moyenne(xa,ya,rayon,imaj1)) *  (((double) imaj2(xb+u,yb+v)) /256 - Moyenne(xb,yb,rayon,imaj2))) ;
		}
	}
	return (moyen/((2*rayon+1)*(2*rayon+1)));
}

double Norme(int x,int y,int rayon,image imaj)
{
return sqrt(Scalaire(x,y,x,y,rayon,imaj,imaj));
}

double LaNorme(int x,int y)
{
return sqrt((double) (x*x+y*y));
}


double CorrelCroisee(int xa,int ya,int xb,int yb,int rayon,image imaj1,image imaj2)
{
	//cout << "Correlation(" << Scalaire(xa,ya,xb,yb,rayon,imaj1,imaj2) << "_" <<Norme(xa,ya,rayon,imaj1)<< "_" <<Norme(xb,yb,rayon,imaj2) <<endl;
			//if (Manuel==1) Click();
	return (Scalaire(xa,ya,xb,yb,rayon,imaj1,imaj2)/(Norme(xa,ya,rayon,imaj1)*Norme(xb,yb,rayon,imaj2)));
}

/*
Corrlation :

Prend en entre deux images sorties de la fonction Harris,
et stocke dans les tableaux Z,T,X,Y les coordonnes (ximage2,
yimage2, ximage1, yimage1) des quatre paires de points de
Harris qui correspondent. rayon est le rayon de la corrlation,
et Manuel indique l'avance automatique ou pas.
*/
void Correlation(image h1,image h2,image pic1, image pic2,int rayon,double* Z, double* T, double*X, double* Y,int Manuel)
{
double correlation[N];
double ZZ[1000];
double TT[1000];
double XX[1000];
double YY[1000];
int w=pic1.width();
int h=pic1.height();
int pointstrouves1=0;

	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (h1(i,j)==255)
			{
				XX[pointstrouves1]=i;
				YY[pointstrouves1]=j;
				pointstrouves1++;
			}
		}
	}

int pointstrouves2=0;
	for (int i=0;i<w;i++)
	{
		for	(int j=0;j<h;j++)
		{
			if (h2(i,j)==255)
			{
				ZZ[pointstrouves2]=i;
				TT[pointstrouves2]=j;
				pointstrouves2++;
			}
		}
	}

//cout << ZZ[pointstrouves2-1]<<","<<TT[pointstrouves2-1] <<endl;
for (int i=0;i<N;i++)
{
	correlation[i]=-1;
}

double pourcent=0;
double correltrouvee=0;
double meilleurelocale;
double mincorrel=-1;
int compteur, trouve, meilleurj;
for (int i=0;i<pointstrouves1;i++)
	{
		meilleurelocale=-1;
		for	(int j=0;j<pointstrouves2;j++)
		{
			correltrouvee=CorrelCroisee(XX[i],YY[i],ZZ[j],TT[j],rayon,pic1,pic2);
			if (correltrouvee>meilleurelocale)
			{
				meilleurelocale=correltrouvee;
				meilleurj=j;
			}
		}
		correltrouvee=meilleurelocale;
		if (correltrouvee>mincorrel)
		{
			//cout <<mincorrel<< "MIEUX"<<correltrouvee<<"("<<X[i]<< ","<< Y[i]<< ")"<< "("<<Z[i]<< ","<< T[i]<< ")"<<endl;
			compteur=0;
			trouve=0;
			while ((compteur<N) && (trouve==0))
			{			
				if (correlation[compteur]==mincorrel)
				{
					correlation[compteur]=correltrouvee;
					Z[compteur]=ZZ[meilleurj];
					T[compteur]=TT[meilleurj];
					X[compteur]=XX[i];
					Y[compteur]=YY[i];
					trouve=1;
					//cout << i<< "("<<X[i]<< ","<< Y[i]<< ")"<< "("<<Z[i]<< ","<< T[i]<< ")"<<endl;
				}
				mincorrel=correltrouvee;
				compteur++;
			
				for (int i=0;i<N;i++)
				{
					if (correlation[i]<mincorrel)
						mincorrel=correlation[i];
				}
			}
	//		cout << "Correlation("<<i <<","<<j<<") : "<<correltrouvee << endl;
		}

		if ((((double) i)/pointstrouves1)>pourcent+0.1)
		{
			pourcent=(((double) i)/pointstrouves1);
			cout <<"Correlation : "<< ((int) (pourcent*10))*10 << "%"<<endl;
		}
	}


cout << "Meilleurs points de Harris trouves :"<<endl;
for (int i=0;i<N;i++)
{
	h1((int) X[i]+1,(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i]-1)=255;
	h1((int) X[i]+1,(int) Y[i]-1)=255;
	h1((int) X[i],(int) Y[i]-1)=255;
	h1((int) X[i],(int) Y[i]+1)=255;
	h1((int) X[i]-1,(int) Y[i])=255;
	h1((int) X[i]+1,(int) Y[i])=255;
	
	h2((int) Z[i]+1,(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i]-1)=255;
	h2((int) Z[i]+1,(int) T[i]-1)=255;
	h2((int) Z[i],(int) T[i]-1)=255;
	h2((int) Z[i],(int) T[i]+1)=255;
	h2((int) Z[i]-1,(int) T[i])=255;
	h2((int) Z[i]+1,(int) T[i])=255;
	
	cout << "Image1("<<X[i]<< ","<< Y[i]<< ") - Image2("<<Z[i]<< ","<< T[i]<< ")"<<endl;
h1.display();
h2.display(pic1.width(),0);
if (Manuel==1) Click();

}

}

double Proportion(int xa,int ya,int xb,int yb,int xc,int yc)
{
return (LaNorme(xa-xb,ya-yb)/LaNorme(xc-xb,yc-yb));
}


/*
Voil les deux fonctions initialement prvues pour l'utilisation de LMS.
Comme LMS plante dans ce cas, on a utilis une mthode alternative (cf main())

//=======================================================
// Estimator pour H avec 4 paires de points.
//(X2,Y2)=H(X1,Y1)
//(X4,Y4)=H(X3,Y3)
//(X6,Y6)=H(X5,Y5)
//(X8,Y8)=H(X7,Y7)

int estimatorH(double params[], // output: estimated parameter vector 
			   int nb, // input: number of data to be used 
			   const int indexes[] // input: indexes of data to be used 
	      )	
{
	if (nb!=4)
		return 0;
	double x1=X[indexes[0]],y1=Y[indexes[0]];
	double x2=Z[indexes[0]],y2=T[indexes[0]];
	double x3=X[indexes[1]],y3=Y[indexes[1]];
	double x4=Z[indexes[1]],y4=T[indexes[1]];
	double x5=X[indexes[2]],y5=Y[indexes[2]];
	double x6=Z[indexes[2]],y6=T[indexes[2]];
	double x7=X[indexes[3]],y7=Y[indexes[3]];
	double x8=Z[indexes[3]],y8=T[indexes[3]];
	//On pourrait utiliser des tableaux, mais ca sera plus lisible ainsi par la suite

	//inclure peut-tre ici une liste de tests de divisibilit...
	if (x1=x3) return 0; //On pourrait dans ce cas biaiser en prenant x1-x5, etc...

	// Calcul de h7, totaux intermdiaires...
	double D1=(y1-y3)*(x1-x5)-(y1-y5)*(x1-x3);
	double D2=(y1-y3)*(x1-x7)-(y1-y7)*(x1-x3);
	double T1=((y1*x2-y3*x4)*(x1-x7)-(y1*x2-y7*x8)*(x1-x3))/D2 -((y1*x2-y3*x4)*(x1-x5)-(y1*x2-y5*x6)*(x1-x3))/D1;
	double T2=((x2-x4)*(x1-x7)-(x2-x8)*(x1-x3))/D2 -((x2-x4)*(x1-x5)-(x2-x6)*(x1-x3))/D1;
	double T3=((x1*x2-x3*x4)*(x1-x5)-(x1*x2-x5*x6)*(x1-x3))/D1 -((x1*x2-x3*x4)*(x1-x7)-(x1*x2-x7*x8)*(x1-x3))/D2;

	double T4=((y1*y2-y3*y4)*(x1-x7)-(y1*y2-y7*y8)*(x1-x3))/D2 -((y1*y2-y3*y4)*(x1-x5)-(y1*y2-y5*y6)*(x1-x3))/D1;
	double T5=((y2-y4)*(x1-x7)-(y2-y8)*(x1-x3))/D2 -((y2-y4)*(x1-x5)-(y2-y6)*(x1-x3))/D1;
	double T6=((x1*y2-x3*y4)*(x1-x5)-(x1*y2-x5*y6)*(x1-x3))/D1 -((x1*y2-x3*y4)*(x1-x7)-(x1*y2-x7*y8)*(x1-x3))/D2;
	// Correspond  h6*T3=h7*T1+T2

	params[7]=(T5/T6-T2/T3)/(T1/T3-T4/T6);
	// Plus qu' tout rcup...
	params[6]=(params[7]*T1+T2)/T3;
	double P1=params[6]*x1+params[7]*y1+1;
	double P3=params[6]*x3+params[7]*y3+1;
	double P5=params[6]*x5+params[7]*y5+1;
	params[1]=((P1*x2-P3*x4)*(x1-x5)-(P1*x2-P5*x6)*(x1-x3))/D1;
	params[4]=((P1*y2-P3*y4)*(x1-x5)-(P1*y2-P5*y6)*(x1-x3))/D1;
	params[0]=(P1*x2-P3*x4-params[1]*(y1-y3))/(x1-x3);
	params[3]=(P1*y2-P3*x4-params[4]*(y1-y3))/(x1-x3);
	params[2]=P1*x2-params[0]*x1-params[1]*y1;
	params[5]=P1*y2-params[3]*x1-params[4]*y1;
	return 1; //Yeepee!
}


// Erreurs au carr quand on prend params
void residualH(const double params[], // input: parameter vector 
			   int nb, // input: number of residuals to be computed 
			   const int indexes[], // input: indexes of data to be used 
			   double resid[] // output: computed residuals 
	      )		
{
	for (int i=0;i<nb;i++) {
		double err1=Z[indexes[i]]-(params[0]*X[indexes[i]]+params[1]*Y[indexes[i]]+params[3])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		double err2=T[indexes[i]]-(params[3]*X[indexes[i]]+params[4]*Y[indexes[i]]+params[5])/(params[6]*X[indexes[i]]+params[7]*Y[indexes[i]]+1);
		resid[i]=err1*err1+err2*err2;
	}
}
//=======================================================
*/



int main()
{
	// Lecture de l'image pour avoir la bonne taille et ouvrir la fentre adapte.
		
	int diametre=Diam;

	string nomfichier1="";
	string nomfichier2="";
	string ReponseManuel="";
	
	//Mode avance manuelle=1 si on veut voir les diffrentes tapes, 0 sinon
    int Manuel;
	cout << "Voulez-vous cliquer entre chaque etape (tapez y)"<< endl << "ou laisser le programme avancer tout seul (tapez n) ?"<<endl;
	getline(cin,ReponseManuel);
	const char* RepMan=ReponseManuel.c_str();
	if ((ReponseManuel=="y") || (ReponseManuel=="yes") || (ReponseManuel=="o") || (ReponseManuel=="oui"))
		Manuel=1;
	else
		Manuel=0;

	cout<<"Nom de fichier de l'image de gauche (qui ne commence pas par '?')"<<endl<<"(entrez ? pour choisir l'image de demo) :"<<endl;
	getline(cin,nomfichier1);
	const char* ffichier1=nomfichier1.c_str();
	const char* ffichier2="";
	if (ffichier1[0]=='?')
	{
		ffichier1=fichier1;
		ffichier2=fichier2;
	}
	else
	{
		cout<<"Nom de fichier de l'image de droite :"<<endl;
		getline(cin,nomfichier2);
		ffichier2=nomfichier2.c_str();
	}
	
	cout<<"Image 1 : "<<ffichier1<<endl;
	cout<<"Image 2 : "<<ffichier2<<endl;

	image A(ffichier1);
	OpenWindow(2*A.width(),A.height());
	
	//Panorama horizontal image 1 a gauche et image 2 a droite :
	//On cherche les points de Harris dans la partie droite de l'image 1
	image pict1=Harris(ffichier1,diametre,(int) (A.width()*0.6),A.width(),0,A.height(),Manuel);
	//On cherche les points de Harris dans la partie droite de l'image 2
	image pict2=Harris(ffichier2,diametre,0,(int) (A.width()*0.4),0,A.height(),Manuel);
	
	
	pict1.display();
	pict2.display(A.width(),0);
	
	if (Manuel==1) Click();

	int rayon=Rayo;
	//int rayon=4;
	image imaj1(ffichier1);
	image imaj2(ffichier2);
	Correlation(pict1,pict2,imaj1,imaj2,rayon,Z,T,X,Y,Manuel);


/*
Voil l'appel de fonction LMS initalement prvu. Comme LMS plante avec les
paramtres suivants, on va utiliser une mthode alternative.

	// Parametres a estimer
	int nbPar=8; // on cherche H...
	double params[8];

	// Avec combien de mesures on peut estimer les parametres
	int nbSamp=4;

	// indices des outliers
	int outliers[N];
	int nbOutliers;*/

//	int ret=LMedS(N,	/* input: the number of Data, which is ordered from 0 */
//					nbSamp,	/* input: size of each randomly selected subset of data */
//					0,		/* input: randomly selected subsets, can be set to NULL,
//							* then a default routine will be used to generate the subsets */
//					0,		  /* input: the number of subsets, not used if sets == NULL */
//					residualH, /* input: function which calculates the residuals */
//					estimatorH,
//					1, /* input: set 1 if `residual' computes the squared residuals */
//					1,	/* input: verbose mode */
//					1,	/* input: maximum number of solutions given by "estimator" */
//					3,	/* input: gate value for outlier detection, a value in [2, 4] */
//					0,	/* input: if > 0.0, LMedS stops when a subset gives a median
//							* residual less than `prematureResidual'.
//							* The specified value must be in accordance with `residual' */
//					nbPar,	/* input: dimension of the parameter vector */
//					.5, /* input: the percentage
//						(between epsilon and 1.0) of good data. An appropriate
//								choice is often 0.5 */
//					params,	/* output: the corresponding estimate of parameters */
//					0,		/* output: best subset retained, can be set to NULL */
//					outliers,	/* output: the outliers detected by LMedS */
//					&nbOutliers	/* output: the number of detected outliers */
  //  );
/*
	if (!ret) {
		cout << "erreur " << ret << endl;
		return 1;
	}
	for (int i=0;i<nbPar;i++)
		cout << "param[" << i << "]=" << params[i] << endl;
	cout << "outliers: ";
	for (int i=0;i<nbOutliers;i++)
		cout << outliers[i] << " ";
	cout << endl;
	return 0;
	if (Manuel==1) Click();
*/


/*
Algo alternatif  la mthode de LMS et de l'homographie pour reconstruire la mosaque :
On slectionne tout d'abord, parmi les 8 meilleurs paires trouves par la mthode
de corrlation, celles qui correspondent le mieux dans les deux images par la mthode
suivante :
On prend trois paires de points.
On obtient donc un triangle dans l'image de gauche et dans celle de droite, on cherche
les triplets de paires de points tels que les angles de ce triangle sont les plus
proches dans l'image de gauche et celle de droite.
On limine au passage les triangles trop plats (angles proches de 0), ou avec un
ou plusieurs cts trop courts.
*/

//On sauvegarde les 2 images de dpart.
dimage orig1= imaj1;
dimage orig2 =imaj2;

int x1,ax2,ax3,ax4,y1,ay2,ay3,ay4,dax4,day4;
int besti,bestj,bestk;
int optimise=0;
double lecoutmin=10000;
double lecout,k1,k2;
//double coutpoint[8];
double UnSinus;


/*
Pour tout triplet de paire de points, on calcule un score pour savoir
s'il correspond bien  trois bons appariements de points.
*/
/*
//Rsum de ce qui suit :
//Dans cette partie, on regardait si les 8 points trouvs correspondaient
//bien  droite dans la base de 2 vecteurs images de vecteurs de
//l'image de gauche

//Un peu plus dtaill :
//pour tout couple de vecteurs (triplets de points)
//on obtient une base dans l'image de gauche et celle de droite, on
//exprime les coordonnes des 5 autres points dans cette base
//et on vrifie que les coordonnes trouves  droite ne sont
//pas trop loignes de celles trouves  gauche.
//Cette mthode ne marche pas super, certainement  cause de points
//parasites, qui ne sont pas limins contrairement  la mthode avec LMS.

//Encore plus dtaill :
//On prend trois paires de points : (x1,y1)(x'1,y'1) (x2,y2)(x'2,y'2) (x3,y3)(x'3,y'3).
//On exprime les 5 paires restantes de points dans la base ((x2-x1,y2-y1),(x3-x1,y3-y1)).
//On obtient alors des coordonnes thoriques de ces 5 points dans la base :
//((x'2-x'1,y'2-y'1),(x'3-x'1,y'3-y'1)). On calcule un cout de diffrence entre les coordonnes
//thoriques et les coordonnes trouves. Ainsi, pour chaque triplet de paires de points,
//on a un cout. Le triplet de cout le plus petit est slectionn. C'est lui qui servira
//de base pour reconstruire l'image.

for (int i=0;i<N;i++)
{
	coutpoint[i]=0;		
	x1=X[1];
	y1=Y[1];	
	for (int j=0;j<N;j++)
	{
		ax2=(X[j]-x1);
		ay2=(Y[j]-y1);
		if (j!=i)
		{
		for (int k=0;k<N;k++)
		{
			ax3=(X[k]-x1);
			ay3=(Y[k]-y1);
			if ((k!=i) && (k!=j))
			{
			lecout=0;
			for (int l=0;l<N;l++)
			{
				if ((l!=i) && (l!=j) && (l!=k))
				{
					ax4=(X[l]-x1);
					ay4=(Y[l]-y1);
					//Coordonnes de x4 dans la base ((x1,x2),(x1,x3)) :
					k2=((double) (ax2*ay4-ay2*ax4))/(ax2*ay3-ay2*ax3);
					k1=((double) (ax3*ay4-ay3*ax4))/(ax3*ay2-ay3*ax2);
					//Coordonnes du vecteur diffrence entre le point attendu
					//et le point trouv correspondant  x4,y4 dans l'image 2.
					dax4=Z[l]-Z[i]-(k1*(Z[k]-Z[i]));
					day4=T[l]-T[i]-(k2*(T[k]-T[i]));
					lecout=lecout + sqrt((double) (dax4*dax4+day4*day4));
				}
			}
			//cout <<"Norme"<< (LaNorme(ax3-ax2,ay3-ay2)/LaNorme(ax3,ay3)) <<endl;
			if ((lecout<lecoutmin) && (ax2>2*diametre) && (ax3>2*diametre)&& (ay2>2*diametre) && (ay3>2*diametre) && (LaNorme(ax3-ax2,ay3-ay2)/LaNorme(ax3,ay3)>0.4))
			{
				lecoutmin=lecout;
				besti=i;
				bestj=j;
				bestk=k;
				optimise=1;
			}	
	//		cout << "Cout ("<<i<<";"<<j<<";"<<k<<") : "<<lecout<<endl;
			coutpoint[i]=coutpoint[i]+lecout;
			}
		}
		}
	}
}
*/

for (int i=0;i<N;i++)
{
	//coutpoint[i]=0;		
	x1=X[i];
	y1=Y[i];	
	for (int j=0;j<N;j++)
	{
		ax2=(X[j]-x1);
		ay2=(Y[j]-y1);
		if (j!=i)
		{
		for (int k=0;k<N;k++)
		{
			ax3=(X[k]-x1);
			ay3=(Y[k]-y1);
			if ((k!=i) && (k!=j))
			{
			lecout=10000;
				
				//On teste que les 3 points choisis ne sont pas trop proches
				//ni sur l'image 1 ni sur la 2.
			if ((abs(X[k]-X[i])>3) && (abs(X[j]-X[i])>3) && (abs(X[k]-X[j])>3) && (abs(Z[k]-Z[i])>3) && (abs(Z[j]-Z[i])>3) && (abs(Z[k]-Z[j])>3) && (abs(Y[k]-Y[i])>3) && (abs(Y[j]-Y[i])>3) && (abs(Y[k]-Y[j])>3) && (abs(T[k]-T[i])>3) && (abs(T[j]-T[i])>3) && (abs(T[k]-T[j])>3))
			{
				//On a choisi 3 points, on prend 2 vecteurs forms par ces trois points,
			    //On calcule le sinus de l'angle form par ces 2 vecteurs
				//afin d'viter que les 3 points soient aligns. Le sinus est calcul
				//avec la formule du produit vectoriel, il devra tre infrieur  0,3.
				UnSinus=abs(
					((X[k]-X[i])*(Y[j]-Y[i])-(Y[k]-Y[i])*(X[j]-X[i]))
					/(LaNorme(X[k]-X[i],Y[k]-Y[i])*LaNorme(X[j]-X[i],Y[j]-X[i]))
					);
				if (UnSinus>0.3)			
				{
					//On a choisi 3 points, a nous donne en particulier deux vecteurs.
					//On vrifie que les correspondants sur l'image 2 de ces deux vecteurs
					//ont les mmes proportion l'un par rapport  l'autre que sur la premire
					//image. Ca nous donne donc un score d'erreur.
					//On refait la mme chose avec un autre couple de deux vecteurs.
					lecout=(
						(abs(Proportion(X[i],Y[i],X[j],Y[j],X[k],Y[k])-Proportion(Z[i],T[i],Z[j],T[j],Z[k],T[k])))/Proportion(X[i],Y[i],X[j],Y[j],X[k],Y[k])
					);
				if (lecout<lecoutmin)
					{
						lecoutmin=lecout;
						besti=i;
						bestj=j;
						bestk=k;
						optimise=1;
					}
				}
			}	
	//		cout << "Cout ("<<i<<";"<<j<<";"<<k<<") : "<<lecout<<endl;
	//		coutpoint[i]=coutpoint[i]+lecout;
			}
		}
		}
	}
}

//Si on n'a pas trouv de triplets de paire de points juste avant, on prend les
//trois qui corrlaient le mieux en dsespoir de cause.
if (optimise==0)
{
	besti=0;
	bestj=1;
	bestk=2;
}

//On va afficher les 3 paires slectionnes au final :
//on efface l'image
for (int i=0;i<(imaj1.width());i++)
{
	for (int j=0;j<(imaj1.height());j++)
	{
		pict1(i,j)=0;
		pict2(i,j)=0;
	}
}

//on affiche les 3 paires :
	pict1((int) X[besti],(int) Y[besti])=255;
	pict1((int) X[bestj],(int) Y[bestj])=255;
	pict1((int) X[bestk],(int) Y[bestk])=255;
	pict2((int) Z[besti],(int) T[besti])=255;
	pict2((int) Z[bestj],(int) T[bestj])=255;
	pict2((int) Z[bestk],(int) T[bestk])=255;
	pict1.display();
	pict2.display(A.width(),0);

	cout << "Cout minimal : ("<<besti<<"("<<X[besti]<<","<<Y[besti]<<") "<<";"<<bestj<<"("<<X[bestj]<<","<<Y[bestj]<<") "<<";"<<"("<<X[bestk]<<","<<Y[bestk]<<") "<<bestk<<") : "<<lecoutmin<<endl;
	cout << "Correspondance ("<<besti<<"("<<Z[besti]<<","<<T[besti]<<") "<<";"<<bestj<<"("<<Z[bestj]<<","<<T[bestj]<<") "<<";"<<"("<<Z[bestk]<<","<<T[bestk]<<") "<<bestk<<")";

if (Manuel==1) Click();

imaj1.display();
int ax,ay;
double iimaj2,jimaj2;
x1=X[besti];
y1=Y[besti];
ax2=X[bestj]-X[besti];
ay2=Y[bestj]-Y[besti];
ax3=X[bestk]-X[besti];
ay3=Y[bestk]-Y[besti];
double fracti,fractj;
int casei,casej;


//On dfinit les images couleurs :
int w1=orig1.width();
int h1=orig1.height();
int w2=orig2.width();
int h2=orig2.height();
const int ww1=orig1.width();
const int hh1=orig1.height();
byte * rimage1;
byte * gimage1;
byte * bimage1;
byte * rimage2;
byte * gimage2;
byte * bimage2;
byte * rfinale1;
byte * gfinale1;
byte * bfinale1;
byte * rfinale2;
byte * gfinale2;
byte * bfinale2;
LoadColorImage(ffichier1,rimage1,gimage1,bimage1,w1,h1);
LoadColorImage(ffichier1,rfinale1,gfinale1,bfinale1,w1,h1);
//PutColorImage(0,0,rimage1,gimage1,bimage1,orig1.width(),orig1.height());
LoadColorImage(ffichier2,rimage2,gimage2,bimage2,w2,h2);
LoadColorImage(ffichier2,rfinale2,gfinale2,bfinale2,w2,h2);
//PutColorImage(0,0,rimage2,gimage2,bimage2,orig2.width(),orig2.height());

/*
On va afficher l'image de droite : pour chaque point de cette
image, on calcule ses coordonnes dans la base de l'image de
gauche, on en dduit ses coordonnes dans la base de l'image
de droite et s'il est bien  l'intrieur de l'image de droite,
on extrait son intensit.
*/
for (int i=0;i<(orig1.width());i++)
{
	for (int j=0;j<(orig1.height());j++)
	{
		ax=i+orig1.width()-X[besti];
		ay=j-Y[besti];
		k2=((double) (ax2*ay-ay2*ax))/(ax2*ay3-ay2*ax3);
		k1=(((double) (ax3*ay-ay3*ax))/(ax3*ay2-ay3*ax2));
		iimaj2=Z[besti]+k1*(Z[bestj]-Z[besti])+k2*(Z[bestk]-Z[besti]);
		jimaj2=T[besti]+k1*(T[bestj]-T[besti])+k2*(T[bestk]-T[besti]);

		if ((iimaj2<orig2.width()-1) && (jimaj2<orig2.height()-1) && (iimaj2>=1) && (jimaj2>=1))
		{		
			/*
			//On ne remplit pas exactement avec la couleur du pixel de l'image 1,
			//mais avec celle du pixel et de 3 de ses voisins en proportions...
			//Ca marche pas vraiment par rapport  la simple extraction de couleur
			//de l'image originale (en plus, on a perte de contraste) et a m'embte
			//bien de n'avoir aucune alternative pour la rsolution de ce problme
			//sans perte de prcision de l'image...
			casei=(int) (iimaj2-0.5);
			casej=(int) (jimaj2-0.5);
			fracti=(iimaj2 - ((int) iimaj2));
			fractj=(jimaj2 - ((int) jimaj2));

			imaj1(i,j)=	(int)	(fracti*fractj*imaj2(casei,casej)
						+	(1-fracti)*fractj*imaj2(casei+1,casej)
						+	fracti*(1-fractj)*imaj2(casei,casej+1)
						+	(1-fracti)*(1-fractj)*imaj2(casei+1,casej+1));
			*/
			imaj1(i,j)=orig2((int) iimaj2,(int) jimaj2);
			rfinale2[i+w2*j]=rimage2[((int) (iimaj2))+w2*(int) (jimaj2)];
			gfinale2[i+w2*j]=gimage2[((int) (iimaj2))+w2*(int) (jimaj2)];
			bfinale2[i+w2*j]=bimage2[((int) (iimaj2))+w2*(int) (jimaj2)];
		}
		else
		{
			imaj1(i,j)=0;
			rfinale2[i+w2*j]=0;
			gfinale2[i+w2*j]=0;
			bfinale2[i+w2*j]=0;
		}
	}
}

//Dans la suite, on se restreint au panorama droite gauche. Les points prcis
//o l'on se restreint seront signals par : (RESTRICTION AU PANORAMA DROITE GAUCHE !!!)
//qui signifie : on procderait de mme pour grer les 3 autres types de panoramas.

//On va maintenant borner les coordonnes, dans l'image 1, de l'intersection
//de l'image 1 avec l'image 2. On  obtiendra donc une zone rectangulaire 
//{M(i,j) tq imin<i<imax et jmin<j<jmax} qui contient l'intersection de 1 avec 2.

//De plus, on construit Coeffs 2, image noire sauf :
// l'intersection de 1 avec 2, pour une abscisse suprieure  celle du barycentre
//des trois points de notre base slectionns ci-dessus : (RESTRICTION AU PANORAMA DROITE GAUCHE !!!)
//En effet, dans la partie noire, on mettra l'image 1 sans se poser de question.
//A la limite avec la partie blanche, comme on se trouve au barycentre de la base
//de 3 pts qui correspondent parfaitement, on est sr d'avoir des couleurs qui
//se juxtaposent bien. Ainsi, dans la zone qui sera blanche, on devra choisir
//les pixels dans l'image 1 ou dans l'image 2.
int imin=imaj2.width();
int imax=0;
int jmin=imaj2.height();
int jmax=0;

dimage Coeffs2=imaj2;
for (int i=0;i<(imaj2.width());i++)
{
	for (int j=0;j<(imaj2.height());j++)
	{
		ax=i-X[besti];
		ay=j-Y[besti];
		k2=((double) (ax2*ay-ay2*ax))/(ax2*ay3-ay2*ax3);
		k1=(((double) (ax3*ay-ay3*ax))/(ax3*ay2-ay3*ax2));
		iimaj2=Z[besti]+k1*(Z[bestj]-Z[besti])+k2*(Z[bestk]-Z[besti]);
		//if (Manuel==1) Click();
		jimaj2=T[besti]+k1*(T[bestj]-T[besti])+k2*(T[bestk]-T[besti]);
		//cout <<"i "<<iimaj2<<" - j "<<jimaj2<<endl;
		if ((iimaj2<imaj2.width()-1) && (jimaj2<imaj2.height()-1) && (iimaj2>=1) && (jimaj2>=1))
		{		
			//imaj2(i,j)=(int) (orig2((int) iimaj2,(int) jimaj2)+orig1(i,j))/2;
			if (i<imin) imin=i;
			if (i>imax) imax=i;
			if (j<jmin) jmin=j;
			if (j>jmax) jmax=j;
			if (i>((X[besti]+X[bestj]+X[bestk])/3))
				Coeffs2(i,j)=255;
			else
				Coeffs2(i,j)=0;
		}
		else
		{
			if ((i<orig1.width()) && (j<orig1.height()))
			{
				imaj2(i,j)=orig1(i,j);
				Coeffs2(i,j)=0;
			}
		}
	}
}


//image Coeffs2=Coeffs.deriche(0,0,min(7,(int) ((abs(X[besti]-X[bestj])+abs(X[besti]-X[bestk])+abs(X[bestk]-X[bestj]))/3)));
//Ca y est, on a notre zone blanche o on va faire coexister les images 1 et 2 :
//On va tout d'abord faire une transition douce entre 1 et 2 en faisant un dgrad
//pour passer du noir (image 1) au blanc (image 2) :
image Coeffs=Coeffs2.deriche(0,0,min(50,(int) ((imax-imin)/2)));
Coeffs.display();
//Click();
//dimage Coeffs2=Coeffs;

int i0=(int) ((X[besti]+X[bestj]+X[bestk])/3);
for (int i=imin;i<=i0;i++)
{
	for (int j=0;j<(imaj2.height());j++)
	{
		if (Coeffs(i,j)<20)
			Coeffs2(i,j)=0;
		else
			Coeffs2(i,j)=255;
	}
}

//Puis, en partant de la limite prcdente entre noir et blanc, on va
//"faire baver l'image gauche 1" (RESTRICTION AU PANORAMA DROITE GAUCHE !!!)
//de gauche  droite, en mettant en noir tous les pixels qui ont un voisin
//de gauche noir et dont l'intensit est trs diffrente sur l'image 2.

//Avec cette mthode, le danger est que l'on se retrouve avec des pixels noirs
//tout  droite de l'intersection entre les deux images (un objet sur le
//rebord droit de l'image de gauche n'est pas prsent sur l'image de droite)
//ce cas ne se rencontre pas beaucoup en pratique. J'ai pens  utiliser
//un coefficient pour indiquer si l'on est trop prs de l'image de
//droite, afin de privilgier le blanc dans ce cas, mais a ne marchait
//pas trs bien. La solution serait de mettre un lger dgrad vers du
//blanc pur, sur une faible largeur,  droite de l'intersection entre
//les deux images.

//Pour les pixels d'intensit trs loigne entre les deux images,
//indique quelle image sera utilise pour complter :
int BonneImage=1;

//Coefficient indique si on est plus proche de l'image 1 de gauche (proche de 0)
//ou de l'image 2 de droite (proche de 1)
double coefficient;

//Attention, pour vrifier si l'intensit d'un pixel est la mme dans
//les deux images, on ne va pas prendre directement l'intensit du pixel,
// cause des diffrences d'intensit globale de lumire des deux images.
//On va donc comparer entre elles non les diffrences d'intensit absolues,
//mais les diffrences d'intensits relatives par rapport  l'intensite "du fond"
//de l'image. On calcule donc ces intensits "de fond" en floutant simplement
//les deux images pour obtenir oorig1 et oorig2.

image oorig1=orig1.deriche(0,0,20);
image oorig2=orig2.deriche(0,0,20);

for (int i=imin;i<imax+1;i++)
{
coefficient=((double) 1-((double)(imax-i)/(imax-i0)));
	for (int j=jmin;j<jmax+1;j++)
	{
		ax=i-X[besti];
		ay=j-Y[besti];
		k2=((double) (ax2*ay-ay2*ax))/(ax2*ay3-ay2*ax3);
		k1=(((double) (ax3*ay-ay3*ax))/(ax3*ay2-ay3*ax2));
		iimaj2=Z[besti]+k1*(Z[bestj]-Z[besti])+k2*(Z[bestk]-Z[besti]);
		jimaj2=T[besti]+k1*(T[bestj]-T[besti])+k2*(T[bestk]-T[besti]);
		if ((iimaj2<imaj2.width()-1) && (jimaj2<imaj2.height()-1) && (iimaj2>=1) && (jimaj2>=1))
		{		
			BonneImage=0;
			if (i>0) {if (Coeffs2(i-1,j)<127) BonneImage++;}
			if (j>0) {if (Coeffs2(i,j-1)<127) BonneImage++;}
			if ((i>0) && (j>0) ) {if (Coeffs2(i-1,j-1)<127) BonneImage++;}
			if ((i>0) && (j<Coeffs2.height()-1) ) {if (Coeffs2(i-1,j+1)<127) BonneImage++;}

			if (abs((int) (orig2((int) iimaj2,(int) jimaj2)-oorig2((int) iimaj2,(int) jimaj2)-orig1(i,j)+oorig1(i,j)))>(double) (10))
			{
				if (BonneImage>0)
				{
					Coeffs2(i,j)=0;//(int) (255*coefficient*coefficient);
				}
			}
			else
				BonneImage=0;
		}
	}
}
Coeffs2.display();
if (Manuel==1) Click();

//On prend le bon consensus entre les deux transitions : celle du fond (simple
//dgrad d'intensit) et celle des objets (faire baver l'image de gauche
//quand il n'y a pas consensus).

for (int i=imin;i<imax+1;i++)
{
coefficient=((double) 1-((double)(imax-i)/(imax-i0)));
	for (int j=jmin;j<jmax+1;j++)
	{
		Coeffs2(i,j)=(int) min((double) (Coeffs2(i,j)),(double) (Coeffs(i,j)));

		//S'il reste du noir  droite de la partie commune aux deux images, il sera
		//dgrad par cette manoeuvre :
		if (i>imax-15) Coeffs2(i,j)=(int) ((255*(i-imax+15)+Coeffs2(i,j)*(imax-i))/15);
	}
}

dimage Coeffs3=Coeffs2;

//On floute  peine tout a
image Coeffs4=Coeffs3.deriche(0,0,0.5);

Coeffs2.display();
if (Manuel==1) Click();

//Voil l'image qui nous indique si on choisit le pixel dans l'image
//de gauche (proportion de noir du pixel), ou dans celle de droite
//(proportion de blanc du pixel).
Coeffs4.display();
if (Manuel==1) Click();

//Il reste  remplir l'intersection :
for (int i=imin;i<imax+1;i++)
{
	for (int j=jmin;j<jmax+1;j++)
	{
		ax=i-X[besti];
		ay=j-Y[besti];
		k2=((double) (ax2*ay-ay2*ax))/(ax2*ay3-ay2*ax3);
		k1=(((double) (ax3*ay-ay3*ax))/(ax3*ay2-ay3*ax2));
		iimaj2=Z[besti]+k1*(Z[bestj]-Z[besti])+k2*(Z[bestk]-Z[besti]);
		jimaj2=T[besti]+k1*(T[bestj]-T[besti])+k2*(T[bestk]-T[besti]);
		if ((iimaj2<imaj2.width()-1) && (jimaj2<imaj2.height()-1) && (iimaj2>=1) && (jimaj2>=1))
		{		
			//On remplit avec un peu de l'image 1 et un peu de la 2.
			imaj2(i,j)=(int) (((Coeffs4(i,j))*(orig2((int) iimaj2,(int) jimaj2))+(255-Coeffs4(i,j))*orig1(i,j))/255);
			rfinale1[i+w2*j]=(int) (((Coeffs4(i,j))*(rimage2[((int) (iimaj2))+w2*(int) (jimaj2)])+(255-Coeffs4(i,j))*rimage1[i+w2*j])/255);
			gfinale1[i+w2*j]=(int) (((Coeffs4(i,j))*(gimage2[((int) (iimaj2))+w2*(int) (jimaj2)])+(255-Coeffs4(i,j))*gimage1[i+w2*j])/255);
			bfinale1[i+w2*j]=(int) (((Coeffs4(i,j))*(bimage2[((int) (iimaj2))+w2*(int) (jimaj2)])+(255-Coeffs4(i,j))*bimage1[i+w2*j])/255);

		}
		else
		{
			//On ne se trouve pas dans l'intersection :
			  imaj2(i,j)=orig1(i,j);
		}
	}
}

imaj2.display();
imaj1.display(orig1.width(),0);
Click();
PutColorImage(0,0,rfinale1,gfinale1,bfinale1,w1,h1);
PutColorImage(w1,0,rfinale2,gfinale2,bfinale2,w2,h2);
Click();

/*
Et l je ne sais pas du tout comment dclarer des tableaux
rfinale, gfinale, et bfinale de taille 2*w*h. Aaaargh !
*/
/*

	cout << "Sous quel nom enregistrez-vous le panorama produit ?"<<endl;
	getline(cin,ReponseManuel);
	const char* ChoixFichier=ReponseManuel.c_str();
	
	const int w=Grrrrrrrrrrrrrrrrrrrrrrrrrrr;	
	byte rfinale[w];
	byte gfinale[w];
	byte bfinale[w];

for (int i=0;i<w1;i++)
{
	for (int j=0;j<h1;j++)
	{
		rfinale[i+j*(w)]=rfinale1[i+j*w1];
		gfinale[i+j*(w)]=rfinale1[i+j*w1];
		bfinale[i+j*(w)]=rfinale1[i+j*w1];
		rfinale[w1+i+j*(w)]=rfinale2[i+j*w2];
		gfinale[w1+i+j*(w)]=gfinale2[i+j*w2];
		bfinale[w1+i+j*(w)]=bfinale2[i+j*w2];
	}
}
PutColorImage(0,0,rfinale,gfinale,bfinale,w1+w2,0);
	SaveColorImage(ChoixFichier,rimage,gimage,bimage,w,h);
	Click;
*/

//imaj2.display();
//imaj1.display(orig1.width(),0);
//Click;
	Terminate();
	return 0;
}
